# -*- coding: utf-8 -*-
##############################################################################
#
#    wms_location module for OpenERP, Location management
#    Copyright (C) 2011 SYLEAM (<http://www.syleam.fr/>)
#              Christophe CHAUVET <christophe.chauvet@syleam.fr>
#
#    This file is a part of wms_location
#
#    wms_location is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    wms_location is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################


__name__ = "Convert crossdock usage to category"


def migrate(cr, v):
    """
    For now, crossdock location is not an internal location and there are a lot of problem with procurement


    :param cr: Current cursor to the database
    :param v: version number
    """
    cr.execute("""SELECT res_id FROM ir_model_data WHERE module='wms_location' and name='location_category_crossdock'""")
    if not cr.fetchone():
        ###
        ## no reference found, we for to create data before
        ##
        cr.execute("""INSERT INTO stock_location_category (code, name, active)
                   VALUES ('CROSSDOCK','Crossdock', true) RETURNING id;""")
        res = cr.fetchone()

        ###
        ## Create the ir_model_data reference
        ##
        cr.execute("""INSERT INTO ir_model_data (module, name, model, res_id, noupdate)
                   VALUES ('wms_location', 'location_category_crossdock', 'stock.location.category', %s, false);""", (res[0],))

        ###
        ## Search all locations affect to the crossdock usage
        ##
        cr.execute("""SELECT id FROM stock_location WHERE usage='crossdock'""")
        loc_ids = [x[0] for x in cr.fetchall()]
        if loc_ids:
            cr.execute("""UPDATE stock_location SET categ_id=%s, usage='internal' WHERE id IN %s""", (res[0], tuple(loc_ids),))

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
